## combblas 1.6.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)

set(CombBLAS_VERSION 1.16.0)

project(CombBLAS VERSION ${CombBLAS_VERSION} LANGUAGES C CXX)


# Main CombBLAS library
add_library(CombBLAS src/CommGrid.cpp src/mmio.c src/MPIType.cpp src/MPIOp.cpp src/MemoryPool.cpp src/hash.cpp)

# require c++14
if("cxx_std_14" IN_LIST CMAKE_CXX_COMPILE_FEATURES) # check if cmake knows about c++14
  target_compile_features(CombBLAS PUBLIC cxx_std_14)
else()
  target_compile_options(CombBLAS PUBLIC $<$<COMPILE_LANGUAGE:CXX>:-std=c++14>)
endif()

# set include directories
target_include_directories(CombBLAS PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
target_include_directories(CombBLAS PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/psort-1.0/include> $<INSTALL_INTERFACE:include>)
target_include_directories(CombBLAS PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/include/CombBLAS)


# MPI and OpenMP dependencies
find_package(MPI REQUIRED)
find_package(OpenMP REQUIRED)

if(TARGET MPI::MPI_CXX) # Use target if available (cmake >= 3.9)
  target_link_libraries(CombBLAS PUBLIC MPI::MPI_CXX)
elseif()
  target_compile_options(CombBLAS PUBLIC "${MPI_CXX_COMPILE_FLAGS}")
  target_link_libraries(CombBLAS PUBLIC MPI_CXX_LINK_LIBRARIES "${MPI_CXX_LINKFLAGS}")
  target_include_directories(CombBLAS PUBLIC "${MPI_CXX_INCLUDE_PATH}")
endif()

if(OPENMP_FOUND OR OpenMP_CXX_FOUND)
  # Set THREADED if OpenMP is found
  target_compile_definitions(CombBLAS PUBLIC THREADED)
  if(TARGET OpenMP::OpenMP_CXX)
    target_link_libraries(CombBLAS PUBLIC OpenMP::OpenMP_CXX)
  else()
    target_compile_options(CombBLAS PUBLIC "${OpenMP_CXX_FLAGS}")
    target_link_libraries(CombBLAS PUBLIC "${OpenMP_CXX_FLAGS}")
  endif()
endif()

ADD_SUBDIRECTORY( usort )
target_link_libraries(CombBLAS PUBLIC Usortlib)

ADD_SUBDIRECTORY( graph500-1.2/generator )
target_link_libraries(CombBLAS PUBLIC GraphGenlib)


# Set up exported configuration
# This allows CombBLAS to be installed in two ways:
#   1. In /usr/local (or whatever prefix is specified)
#   2. Exporting the current build directory. This allows a user to make
#      modifications to CombBLAS and have the changes automatically recompiled for
#      dependent projects.
# Either way, we need to create a CombBLASConfig.cmake.
set(ConfigPackageLocation lib/cmake/CombBLAS)

# Generate version number header
include(GenerateExportHeader)
generate_export_header(CombBLAS)
set_property(TARGET CombBLAS PROPERTY VERSION ${CombBLAS_VERSION})

# installation
install(DIRECTORY include/ DESTINATION include)
install(DIRECTORY psort-1.0/include/ DESTINATION include)
install(TARGETS CombBLAS EXPORT CombBLASTargets
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

include(CMakePackageConfigHelpers)

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASConfigVersion.cmake"
  VERSION ${CombBLAS_VERSION}
  COMPATIBILITY AnyNewerVersion
)

# The following commands allow for option 2.
export(EXPORT CombBLASTargets
  FILE "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASTargets.cmake"
  NAMESPACE CombBLAS::
)
configure_file(cmake/CombBLASConfig.cmake
  "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASConfig.cmake"
  COPYONLY
)

# Allow for option 2
install(EXPORT CombBLASTargets
  FILE
    CombBLASTargets.cmake
  NAMESPACE
    CombBLAS::
  DESTINATION
    ${ConfigPackageLocation}
)
export(PACKAGE CombBLAS)
install(
  FILES
    cmake/CombBLASConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASConfigVersion.cmake"
  DESTINATION
    ${ConfigPackageLocation}
  COMPONENT
    Devel
)

# Testing
ENABLE_TESTING()
INCLUDE(CTest)

ADD_SUBDIRECTORY( ReleaseTests )
ADD_SUBDIRECTORY( Applications )
ADD_SUBDIRECTORY( Ordering )
ADD_SUBDIRECTORY( Applications/SpMSpV-IPDPS2017 )
ADD_SUBDIRECTORY( 3DSpGEMM )

=== 3DSpGEMM/CMakeLists.txt ===
add_executable(mpipspgemm mpipspgemm.cpp)
target_link_libraries(mpipspgemm CombBLAS)

add_executable(test_mpipspgemm test_mpipspgemm.cpp)
target_link_libraries(test_mpipspgemm CombBLAS)

=== Applications/CMakeLists.txt ===
# Top level directory has the include files


ADD_EXECUTABLE( tdbfs TopDownBFS.cpp )
ADD_EXECUTABLE( dobfs DirOptBFS.cpp )
ADD_EXECUTABLE( fbfs FilteredBFS.cpp )
ADD_EXECUTABLE( fmis FilteredMIS.cpp )
ADD_EXECUTABLE( mcl MCL.cpp )
ADD_EXECUTABLE( betwcent BetwCent.cpp )


TARGET_LINK_LIBRARIES( tdbfs CombBLAS)
TARGET_LINK_LIBRARIES( dobfs CombBLAS)
TARGET_LINK_LIBRARIES( fbfs CombBLAS)
TARGET_LINK_LIBRARIES( fmis CombBLAS)
TARGET_LINK_LIBRARIES( mcl CombBLAS)
TARGET_LINK_LIBRARIES( betwcent CombBLAS)

ADD_TEST(NAME BetwCent_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:betwcent> ../TESTDATA/SCALE16BTW-TRANSBOOL/ 10 96 )
ADD_TEST(NAME TopDownBFS_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:tdbfs> Force 17 FastGen)
ADD_TEST(NAME DirOptBFS_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:dobfs> 17 )
ADD_TEST(NAME FBFS_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:fbfs> Gen 16 )
ADD_TEST(NAME FMIS_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:fmis> 17 )

=== Ordering/CMakeLists.txt ===
# Top level directory has the include files


ADD_EXECUTABLE( rcm RCM.cpp )

TARGET_LINK_LIBRARIES( rcm CombBLAS)

ADD_TEST(NAME RCM_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:rcm> er 18 )

=== ReleaseTests/CMakeLists.txt ===
# Top level directory has the include files

ADD_EXECUTABLE( MultTiming MultTiming.cpp )
ADD_EXECUTABLE( MultTest MultTest.cpp )
ADD_EXECUTABLE( ReduceTest ReduceTest.cpp )
ADD_EXECUTABLE( TransposeTest TransposeTest.cpp )
ADD_EXECUTABLE( IteratorTest IteratorTest.cpp )
ADD_EXECUTABLE( IndexingTest IndexingTest.cpp )
ADD_EXECUTABLE( SpAsgnTest SpAsgnTest.cpp )
ADD_EXECUTABLE( GalerkinNew GalerkinNew.cpp )
ADD_EXECUTABLE( IndexingTiming IndexingTiming.cpp )
ADD_EXECUTABLE( FindSparse FindSparse.cpp )
ADD_EXECUTABLE( ParIOTest ParIOTest.cpp )

TARGET_LINK_LIBRARIES( MultTiming CombBLAS)
TARGET_LINK_LIBRARIES( MultTest CombBLAS)
TARGET_LINK_LIBRARIES( ReduceTest CombBLAS)
TARGET_LINK_LIBRARIES( TransposeTest CombBLAS)
TARGET_LINK_LIBRARIES( IteratorTest CombBLAS)
TARGET_LINK_LIBRARIES( IndexingTest CombBLAS)
TARGET_LINK_LIBRARIES( SpAsgnTest CombBLAS)
TARGET_LINK_LIBRARIES( GalerkinNew CombBLAS)
TARGET_LINK_LIBRARIES( IndexingTiming CombBLAS)
TARGET_LINK_LIBRARIES( FindSparse CombBLAS)
TARGET_LINK_LIBRARIES( ParIOTest CombBLAS)


ADD_TEST(NAME Multiplication_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:MultTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx ../TESTDATA/x_65536_halfdense.txt ../TESTDATA/y_65536_halfdense.txt )
ADD_TEST(NAME Reduction_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:ReduceTest> ../TESTDATA/sprand10000 ../TESTDATA/sprand10000_sumcols ../TESTDATA/sprand10000_sumrows)
ADD_TEST(NAME Iterator_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:IteratorTest> ../TESTDATA sprand10000)
ADD_TEST(NAME Transpose_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:TransposeTest> ../TESTDATA betwinput_scale16 betwinput_transposed_scale16)
ADD_TEST(NAME Indexing_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:IndexingTest> ../TESTDATA B_100x100.txt B_10x30_Indexed.txt rand10outta100.txt rand30outta100.txt)
ADD_TEST(NAME SpAsgn_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:SpAsgnTest> ../TESTDATA A_100x100.txt A_with20x30hole.txt dense_20x30matrix.txt A_wdenseblocks.txt 20outta100.txt 30outta100.txt)
ADD_TEST(NAME GalerkinNew_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:GalerkinNew> ../TESTDATA/grid3d_k5.txt ../TESTDATA/offdiag_grid3d_k5.txt ../TESTDATA/diag_grid3d_k5.txt ../TESTDATA/restrict_T_grid3d_k5.txt)
ADD_TEST(NAME FindSparse_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:FindSparse> ../TESTDATA findmatrix.txt)

=== usort/CMakeLists.txt ===
# Top level directory has the include files

ADD_LIBRARY( Usortlib src/parUtils.cpp src/binUtils.cpp )
target_include_directories(Usortlib PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
target_include_directories(Usortlib PRIVATE include/usort)

install(DIRECTORY include/ DESTINATION include)
install(TARGETS Usortlib EXPORT CombBLASTargets
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

=== psort-1.0/driver/Makefile ===
include ./Make.inc

psort: psort_driver.cc
	$(CXX) $(CXXFLAGS) -I../src psort_driver.cc -o psort $(LIBS)
	strip psort

clean:
	rm -f *.o psort results

=== debian/changelog ===
combblas (1.6.2-8) unstable; urgency=medium

  * configure debian/tests/control with Restrictions: allow-stderr
    to ignore warnings about changes in gcc C++ ABI support
    (CombBLAS uses the c++14 standard)
  * update debian patch cmake_multiarch.patch to install cmake config
    files in multiarch location (under CMAKE_INSTALL_LIBDIR)

 -- Drew Parsons <dparsons@debian.org>  Mon, 31 Jan 2022 18:07:21 +0100

combblas (1.6.2-7) unstable; urgency=medium

  * combblas uses cmake to detect MPI, no need to specify mpicc as
    compiler and cross-compiling is simpler then. Closes: Bug#940664.
    - debian patch mpi_build.patch propagates cmake MPI configuration
      to subdirectories where it was missing. Thanks Helmut Grohne.
    - update debian/tests/ReleaseTests_CMakeLists.txt.patch to use
      cmake to find MPI (and OpenMP) for debian/tests (autopkgtest)
  * build tests for debian/tests (autopkgtest) with VERBOSE=1
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Sun, 30 Jan 2022 12:58:19 +0100

combblas (1.6.2-6) unstable; urgency=medium

  * debian patch AWPM_library_38dd27e.patch applies patch from
    guix 38dd27e to adjust AWPM headers for library use.
    Enables operation with other libraries such as SuperLU-Dist, see
    https://github.com/xiaoyeli/superlu_dist/issues/60
  * debian patch GraphGenlib_link_math.patch links GraphGenlib against
    libm (for sqrt,pow,log)
  * install CombBLAS cmake config files
  * debian/tests: run verbose ctest to report test failure details
  * debhelper compatibility level 13
    - mark usr/include/.DS_Store as not-installed
  * Standards-Version: 4.5.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Jan 2021 15:57:35 +1100

combblas (1.6.2-5) unstable; urgency=medium

  * use cmake with -Wno-dev in debian/tests to avoid developer
    warnings (which are written to stderr, inducing test fail)
  * Standards-Version: 4.4.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 25 Nov 2019 11:05:08 +0800

combblas (1.6.2-4) unstable; urgency=medium

  * Standards-Version: 4.4.0
  * debhelper compatibility level 12: debhelper-compat (= 12)
  * don't install .dot and .md5 files with docs.
    Thanks Chris Lamb. Closes: #931102.
  * Build-Depends: graphviz to provide dot for building doc images.

 -- Drew Parsons <dparsons@debian.org>  Sat, 14 Sep 2019 22:43:46 +0800

combblas (1.6.2-3) unstable; urgency=medium

  * install header files for BipartiteMatchings (used by SuperLU-Dist)

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Nov 2018 17:03:49 +0800

combblas (1.6.2-2) unstable; urgency=medium

  * add debian/tests (autopkgtest)
  * mark libcombblas-docs as Multi-Arch: foreign

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Nov 2018 01:26:15 +0800

combblas (1.6.2-1) unstable; urgency=medium

  * Initial release (Closes: #910002)
    - keep upstream testdata_combblas1.6.1.tgz in debian dir to
      provide TESTDATA for build-time tests

 -- Drew Parsons <dparsons@debian.org>  Wed, 03 Oct 2018 01:31:59 +0800

=== debian/control ===
Source: combblas
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake (>= 3.3),
 doxygen,
 graphviz,
 mpi-default-dev
Standards-Version: 4.6.0
Section: libs
Homepage: https://people.eecs.berkeley.edu/~aydin/CombBLAS/html/index.html
Vcs-Browser: https://salsa.debian.org/science-team/combblas
Vcs-Git: https://salsa.debian.org/science-team/combblas.git

Package: libcombblas-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcombblas1.16.0 (= ${binary:Version}), ${misc:Depends}
Suggests: libcombblas-docs
Description: an extensible parallel graph library for graph analytics
 The Combinatorial BLAS (CombBLAS) is an extensible distributed-memory
 parallel graph library offering a small but powerful set of linear
 algebra primitives specifically targeting graph analytics.
 .
   - The Combinatorial BLAS development influences the Graph BLAS
     standardization process.
   - It achieves scalability via its two dimensional distribution and
     coarse-grained parallelism.
   - CombBLAS powers HipMCL, a highly-scalable parallel implementation of
     the Markov Cluster Algorithm (MCL).
   - Operations among sparse matrices and vectors use arbitrary user
     defined semirings.
 .
 This package provides development files for building client
 applications against combblas.

Package: libcombblas1.16.0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: an extensible parallel graph library for graph analytics
 The Combinatorial BLAS (CombBLAS) is an extensible distributed-memory
 parallel graph library offering a small but powerful set of linear
 algebra primitives specifically targeting graph analytics.
 .
   - The Combinatorial BLAS development influences the Graph BLAS
     standardization process.
   - It achieves scalability via its two dimensional distribution and
     coarse-grained parallelism.
   - CombBLAS powers HipMCL, a highly-scalable parallel implementation of
     the Markov Cluster Algorithm (MCL).
   - Operations among sparse matrices and vectors use arbitrary user
     defined semirings.
 .
 This package provides the combblas shared library.

Package: libcombblas-docs
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libcombblas-dev
Description: an extensible parallel graph library for graph analytics (docs)
 The Combinatorial BLAS (CombBLAS) is an extensible distributed-memory
 parallel graph library offering a small but powerful set of linear
 algebra primitives specifically targeting graph analytics.
 .
   - The Combinatorial BLAS development influences the Graph BLAS
     standardization process.
   - It achieves scalability via its two dimensional distribution and
     coarse-grained parallelism.
   - CombBLAS powers HipMCL, a highly-scalable parallel implementation of
     the Markov Cluster Algorithm (MCL).
   - Operations among sparse matrices and vectors use arbitrary user
     defined semirings.
 .
 This package provides full HTML documentation for the CombBLAS API.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/architecture.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
LIBDIR = $(CURDIR)/$(BUILDDIR)

# Allow test programs that uses OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false


%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- \
            -DBUILD_SHARED_LIBS=ON \
            -DCMAKE_SKIP_RPATH=ON \
            -DMPIEXEC_PREFLAGS=--allow-run-as-root
	tar xzf debian/testdata_combblas*.tgz -C $(BUILDDIR)


override_dh_auto_test-arch:
	LD_LIBRARY_PATH=$(LIBDIR):$(LIBDIR)/usort:$(LIBDIR)/graph500-1.2/generator:$${LD_LIBRARY_PATH} \
	    dh_auto_test || /bin/true

override_dh_auto_test-indep:
	# no tests for docs

override_dh_auto_install:
	dh_auto_install
	# MacOS auxiliary file, should never have been installed
	rm -f debian/tmp/usr/include/CombBLAS/._CombBLAS.h

override_dh_installchangelogs:
	dh_installchangelogs release-notes.html

override_dh_installdocs-indep:
	doxygen
	dh_installdocs -X.dot -X.md5

## combblas 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
project(CombBLAS VERSION 1.16.0 LANGUAGES C CXX)

# require c++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS OFF)

# Main CombBLAS library
add_library(CombBLAS src/CommGrid.cpp src/mmio.c src/MPIType.cpp src/MPIOp.cpp src/MemoryPool.cpp src/hash.cpp)

# require c++14 in CombBLAS interface
if("cxx_std_14" IN_LIST CMAKE_CXX_COMPILE_FEATURES) # Use language feature if available (CMake >= 3.8)
  target_compile_features(CombBLAS PUBLIC cxx_std_14)
else()
  # Use C++14-specific features for CMake >= 3.3, which will force the appropriate language level flags.
  target_compile_features(CombBLAS PUBLIC cxx_return_type_deduction)
endif()

# set include directories
target_include_directories(CombBLAS PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
target_include_directories(CombBLAS PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/psort-1.0/include> $<INSTALL_INTERFACE:include>)
target_include_directories(CombBLAS PRIVATE include/CombBLAS)

# MPI and OpenMP dependencies
find_package(MPI REQUIRED)
find_package(OpenMP)

if(TARGET MPI::MPI_CXX) # Use target if available (CMake >= 3.9)
  target_link_libraries(CombBLAS PUBLIC MPI::MPI_CXX)
else()
  target_compile_options(CombBLAS PUBLIC "${MPI_CXX_COMPILE_FLAGS}")
  target_link_libraries(CombBLAS PUBLIC "${MPI_CXX_LIBRARIES}" "${MPI_CXX_LINKFLAGS}")
  target_include_directories(CombBLAS PUBLIC "${MPI_CXX_INCLUDE_PATH}")
endif()

if(TARGET OpenMP::OpenMP_CXX) # Use target if available (CMake >= 3.9)
  target_compile_definitions(CombBLAS PUBLIC THREADED)
  target_link_libraries(CombBLAS PUBLIC OpenMP::OpenMP_CXX)
elseif(OPENMP_FOUND)
  target_compile_definitions(CombBLAS PUBLIC THREADED)
  target_compile_options(CombBLAS PUBLIC "${OpenMP_CXX_FLAGS}")
  target_link_libraries(CombBLAS PUBLIC "${OpenMP_CXX_FLAGS}")
endif()

add_subdirectory(usort)
target_link_libraries(CombBLAS PUBLIC Usortlib)

add_subdirectory(graph500-1.2/generator)
target_link_libraries(CombBLAS PUBLIC GraphGenlib)

# Set up exported configuration
# This allows CombBLAS to be installed in two ways:
#   1. In /usr/local (or whatever prefix is specified)
#   2. Exporting the current build directory. This allows a user to make
#      modifications to CombBLAS and have the changes automatically recompiled for
#      dependent projects.
# Either way, we need to create a CombBLASConfig.cmake.
set(ConfigPackageLocation lib/cmake/CombBLAS)

# Generate version number header
include(GenerateExportHeader)
generate_export_header(CombBLAS)
set_target_properties(CombBLAS PROPERTIES VERSION ${CombBLAS_VERSION})

# installation
install(DIRECTORY include/ DESTINATION include)
install(DIRECTORY psort-1.0/include/ DESTINATION include)
install(TARGETS CombBLAS EXPORT CombBLASTargets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
        INCLUDES DESTINATION include
        )

include(CMakePackageConfigHelpers)

write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASConfigVersion.cmake"
    VERSION ${CombBLAS_VERSION}
    COMPATIBILITY AnyNewerVersion
)

# The following commands allow for option 2.
export(EXPORT CombBLASTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASTargets.cmake"
       NAMESPACE CombBLAS::
       )
configure_file(cmake/CombBLASConfig.cmake
               "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASConfig.cmake"
               COPYONLY
               )

# Allow for option 2
install(EXPORT CombBLASTargets
        FILE
        CombBLASTargets.cmake
        NAMESPACE
        CombBLAS::
        DESTINATION
        ${ConfigPackageLocation}
        )
export(PACKAGE CombBLAS)
install(
    FILES
    cmake/CombBLASConfig.cmake
    "${CMAKE_CURRENT_BINARY_DIR}/CombBLAS/CombBLASConfigVersion.cmake"
    DESTINATION
    ${ConfigPackageLocation}
    COMPONENT
    Devel
)

# Testing
enable_testing()
include(CTest)

add_subdirectory(ReleaseTests)
add_subdirectory(Applications)
add_subdirectory(Applications/Ordering)
add_subdirectory(Applications/BipartiteMatchings)
add_subdirectory(Applications/SpMSpV-IPDPS2017)
add_subdirectory(3DSpGEMM)

=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 ADD_EXECUTABLE( fmis FilteredMIS.cpp )
 ADD_EXECUTABLE( mcl MCL.cpp )
 ADD_EXECUTABLE( betwcent BetwCent.cpp )
-
+ADD_EXECUTABLE(lacc CC.cpp)
 
 TARGET_LINK_LIBRARIES( tdbfs CombBLAS)
 TARGET_LINK_LIBRARIES( dobfs CombBLAS)
@@ -15,6 +15,7 @@
 TARGET_LINK_LIBRARIES( fmis CombBLAS)
 TARGET_LINK_LIBRARIES( mcl CombBLAS)
 TARGET_LINK_LIBRARIES( betwcent CombBLAS)
+TARGET_LINK_LIBRARIES( lacc CombBLAS)
 
 ADD_TEST(NAME BetwCent_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:betwcent> ../TESTDATA/SCALE16BTW-TRANSBOOL/ 10 96 )
 ADD_TEST(NAME TopDownBFS_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:tdbfs> Force 17 FastGen)

=== ReleaseTests/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,13 @@
 ADD_EXECUTABLE( IndexingTiming IndexingTiming.cpp )
 ADD_EXECUTABLE( FindSparse FindSparse.cpp )
 ADD_EXECUTABLE( ParIOTest ParIOTest.cpp )
+ADD_EXECUTABLE( GenWrMat GenWriteMatrix.cpp )
+ADD_EXECUTABLE( BlockedSpGEMM BlockedSpGEMM.cpp )
+ADD_EXECUTABLE( SpGEMM3DTest SpGEMM3DTest.cpp )
+ADD_EXECUTABLE( HashSpGEMMTest HashSpGEMMTest.cpp )
+ADD_EXECUTABLE( InducedSubgraphsTest InducedSubgraphsTest.cpp )
+ADD_EXECUTABLE( PruneColumn PruneColumn.cpp )
+ADD_EXECUTABLE( KTipsTest KTipsTest.cpp )
 
 TARGET_LINK_LIBRARIES( MultTiming CombBLAS)
 TARGET_LINK_LIBRARIES( MultTest CombBLAS)
@@ -23,9 +30,18 @@
 TARGET_LINK_LIBRARIES( IndexingTiming CombBLAS)
 TARGET_LINK_LIBRARIES( FindSparse CombBLAS)
 TARGET_LINK_LIBRARIES( ParIOTest CombBLAS)
+TARGET_LINK_LIBRARIES( GenWrMat CombBLAS)
+TARGET_LINK_LIBRARIES( BlockedSpGEMM CombBLAS)
+TARGET_LINK_LIBRARIES( SpGEMM3DTest CombBLAS)
+TARGET_LINK_LIBRARIES( HashSpGEMMTest CombBLAS)
+TARGET_LINK_LIBRARIES( InducedSubgraphsTest CombBLAS)
+TARGET_LINK_LIBRARIES( PruneColumn CombBLAS)
+TARGET_LINK_LIBRARIES( KTipsTest CombBLAS)
 
-
+ADD_TEST(NAME GenMMWrite_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:GenWrMat> 20 16 1 scale20_ef16_symmetric.mtx)
 ADD_TEST(NAME Multiplication_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:MultTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx ../TESTDATA/x_65536_halfdense.txt ../TESTDATA/y_65536_halfdense.txt )
+ADD_TEST(NAME SpGEMM3D_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 16 $<TARGET_FILE:SpGEMM3DTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx )
+ADD_TEST(NAME HashSpGEMMTest COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 1 $<TARGET_FILE:HashSpGEMMTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx )
 ADD_TEST(NAME Reduction_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:ReduceTest> ../TESTDATA/sprand10000 ../TESTDATA/sprand10000_sumcols ../TESTDATA/sprand10000_sumrows)
 ADD_TEST(NAME Iterator_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:IteratorTest> ../TESTDATA sprand10000)
 ADD_TEST(NAME Transpose_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:TransposeTest> ../TESTDATA betwinput_scale16 betwinput_transposed_scale16)

=== graph500-1.2/Makefile ===
# -*- Makefile -*-
# Copyright 2010,  Georgia Institute of Technology, USA.
# See COPYING for license.
BUILD_OPENMP = No
BUILD_XMT = No
include make.inc

GRAPH500_SOURCES=graph500.c options.c rmat.c kronecker.c verify.c prng.c \
	xalloc.c timer.c 

BIN=seq-list/seq-list seq-csr/seq-csr

ifeq ($(BUILD_OPENMP), Yes)
BIN += omp-csr/omp-csr
endif

ifeq ($(BUILD_MPI), Yes)
BIN += mpi/graph500_mpi_simple
endif

ifeq ($(BUILD_XMT), Yes)
BIN = xmt-csr/xmt-csr xmt-csr-local/xmt-csr-local
endif

GENERATOR_OBJS_SEQ=btrd_binomial_distribution.o splittable_mrg.o	\
	mrg_transitions.o graph_generator.o permutation_gen.o		\
	make_graph.o scramble_edges.o utils.o

.PHONY: all
all: $(BIN)

seq-list/seq-list: seq-list/seq-list.c $(GRAPH500_SOURCES) libgenerator-seq.a
seq-csr/seq-csr: seq-csr/seq-csr.c $(GRAPH500_SOURCES) libgenerator-seq.a

omp-csr/omp-csr: CFLAGS:=$(CFLAGS) $(CFLAGS_OPENMP)
omp-csr/omp-csr: omp-csr/omp-csr.c $(GRAPH500_SOURCES) libgenerator-omp.a

xmt-csr/xmt-csr: CFLAGS:=$(CFLAGS) -pl xmt-csr/xmt-csr.pl
xmt-csr/xmt-csr: xmt-csr/xmt-csr.c $(GRAPH500_SOURCES) \
	$(addprefix generator/,$(patsubst %.o,%.c,$(GENERATOR_OBJS_SEQ)))

xmt-csr-local/xmt-csr-local: CFLAGS:=$(CFLAGS) -pl xmt-csr-local/xmt-csr-local.pl
xmt-csr-local/xmt-csr-local: xmt-csr-local/xmt-csr-local.c $(GRAPH500_SOURCES) \
	$(addprefix generator/,$(patsubst %.o,%.c,$(GENERATOR_OBJS_SEQ)))

generator/generator_test_seq: generator/generator_test_seq.c libgenerator-seq.a

generator/generator_test_omp: generator/generator_test_omp.c libgenerator-omp.a

libgenerator-seq.a: libgenerator-seq.a($(addprefix generator/,$(GENERATOR_OBJS_SEQ)))
	ranlib libgenerator-seq.a

libgenerator-seq.a($(addprefix generator/,$(GENERATOR_OBJS_SEQ))): CFLAGS:=$(CFLAGS) $(CFLAGS_OPENMP)
libgenerator-seq.a($(addprefix generator/,$(GENERATOR_OBJS_SEQ))): CPPFLAGS=-DGRAPH_GENERATOR_SEQ

libgenerator-omp.a: libgenerator-omp.a($(addprefix generator/,$(GENERATOR_OBJS_SEQ)))
	ranlib libgenerator-omp.a

libgenerator-omp.a($(addprefix generator/,$(GENERATOR_OBJS_SEQ))): CPPFLAGS=-DGRAPH_GENERATOR_OMP

mpi/graph500_mpi_simple mpi/graph500_mpi_one_sided:
	$(MAKE) -C mpi

.PHONY:	clean
clean:
	rm -f libgenerator-omp.a libgenerator-seq.a \
		generator/generator_test_seq generator/generator_test_omp \
		$(BIN)
	-$(MAKE) -C mpi clean

=== staticSP/Makefile ===
INCDIR = $(HOME)
INCADD = -I$(INCDIR) -I/usr/include/python2.4
COMBBLAS = ../../trunk/CombBLAS

OPT = -DNDEBUG -O3 -DMPICH_IGNORE_CXX_SEEK -Wreturn-type -w 
DEB = -g -O0 -fno-inline -DMPICH_IGNORE_CXX_SEEK -DTR1 #-DDEBUG
COMPILER = mpicxx
FLAGS = $(OPT) -fPIC -DCOMBBLAS_TR1
LINKFLAGS = #-undefined dynamic_lookup

all: ssp 

%.o : %.c %.h
	$(COMPILER) $(INCADD) $(FLAGS) -c $< -o $@

#
# build CombBLAS
#

CommGrid.o:	$(COMBBLAS)/CommGrid.cpp $(COMBBLAS)/CommGrid.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o CommGrid.o $(COMBBLAS)/CommGrid.cpp

MPIType.o:	$(COMBBLAS)/MPIType.cpp $(COMBBLAS)/MPIType.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o MPIType.o $(COMBBLAS)/MPIType.cpp

MemoryPool.o: $(COMBBLAS)/MemoryPool.cpp $(COMBBLAS)/SpDefs.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o MemoryPool.o $(COMBBLAS)/MemoryPool.cpp


# build ssp

ssp.o: ssp.cpp $(COMBBLAS)/CombBLAS.h Node.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o ssp.o ssp.cpp

ssp:	MemoryPool.o CommGrid.o MPIType.o ssp.o
	$(COMPILER) $(INCADD) $(FLAGS) -o ssp ssp.o MemoryPool.o CommGrid.o MPIType.o


clean:
	rm -f ssp 
	rm -f *.o
	rm -f *.a
	rm -f temp* 

cleanout:
	rm out.*
	rm err.*

=== tdsp/Makefile ===
INCDIR = $(HOME)
INCADD = -I$(INCDIR) -I/usr/include/python2.4
COMBBLAS = ../../trunk/CombBLAS

OPT = -DNDEBUG -O3 -DMPICH_IGNORE_CXX_SEEK -Wreturn-type -w 
DEB = -g -O0 -fno-inline -DMPICH_IGNORE_CXX_SEEK -DTR1 #-DDEBUG
COMPILER = mpicxx
FLAGS = $(OPT) -fPIC -DCOMBBLAS_TR1
LINKFLAGS = #-undefined dynamic_lookup

all: tdsp 

%.o : %.c %.h
	$(COMPILER) $(INCADD) $(FLAGS) -c $< -o $@

#
# build CombBLAS
#

CommGrid.o:	$(COMBBLAS)/CommGrid.cpp $(COMBBLAS)/CommGrid.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o CommGrid.o $(COMBBLAS)/CommGrid.cpp

MPIType.o:	$(COMBBLAS)/MPIType.cpp $(COMBBLAS)/MPIType.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o MPIType.o $(COMBBLAS)/MPIType.cpp

MemoryPool.o: $(COMBBLAS)/MemoryPool.cpp $(COMBBLAS)/SpDefs.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o MemoryPool.o $(COMBBLAS)/MemoryPool.cpp


# build tdsp

tdsp.o: tdsp.cpp $(COMBBLAS)/CombBLAS.h Node.h Ft.h
	$(COMPILER) $(INCADD) $(FLAGS) -c -o tdsp.o tdsp.cpp

tdsp:	MemoryPool.o CommGrid.o MPIType.o tdsp.o
	$(COMPILER) $(INCADD) $(FLAGS) -o tdsp tdsp.o MemoryPool.o CommGrid.o MPIType.o


clean:
	rm -f tdsp 
	rm -f *.o
	rm -f *.a
	rm -f temp* 

cleanout:
	rm out.*
	rm err.*

=== usort/CMakeLists.txt ===
# Top level directory has the include files

add_library(Usortlib src/parUtils.cpp src/binUtils.cpp)
target_include_directories(Usortlib PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
target_include_directories(Usortlib PRIVATE include/usort)

if(TARGET MPI::MPI_CXX) # Use target if available (CMake >= 3.9)
  target_link_libraries(Usortlib PUBLIC MPI::MPI_CXX)
else()
  target_compile_options(Usortlib PUBLIC "${MPI_CXX_COMPILE_FLAGS}")
  target_link_libraries(Usortlib PUBLIC "${MPI_CXX_LIBRARIES}" "${MPI_CXX_LINKFLAGS}")
  target_include_directories(Usortlib PUBLIC "${MPI_CXX_INCLUDE_PATH}")
endif()

install(DIRECTORY include/ DESTINATION include)
install(TARGETS Usortlib EXPORT CombBLASTargets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
        INCLUDES DESTINATION include
        )

=== Applications/BipartiteMatchings/CMakeLists.txt ===
# Top level directory has the include files


ADD_EXECUTABLE( bpml BPMaximalMatching.cpp )
ADD_EXECUTABLE( bpmm BPMaximumMatching.cpp )
ADD_EXECUTABLE( awpm ApproxWeightPerfectMatching.cpp )


TARGET_LINK_LIBRARIES( bpml CombBLAS)
TARGET_LINK_LIBRARIES( bpmm CombBLAS )
TARGET_LINK_LIBRARIES( awpm CombBLAS )

ADD_TEST(NAME BPML_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:bpml> er 12 8  )
ADD_TEST(NAME BPMM_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:bpmm> er 12 8  )

=== Applications/Ordering/CMakeLists.txt ===
# Top level directory has the include files


ADD_EXECUTABLE( rcm RCM.cpp )

TARGET_LINK_LIBRARIES( rcm CombBLAS)

ADD_TEST(NAME RCM_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:rcm> er 12 )

=== Applications/SpMSpV-IPDPS2017/CMakeLists.txt ===
# Top level directory has the include files


ADD_EXECUTABLE( SpMSpVBench SpMSpVBench.cpp )

TARGET_LINK_LIBRARIES( SpMSpVBench CombBLAS)

ADD_TEST(NAME SpMSpVBench_test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:SpMSpVBench> -rmat 18 )

=== Applications/mcl-runs/Makefile ===
CC = g++ 
FLAGS = -fopenmp -O2 -DNDEBUG 

all: mclconvert fscore

mclconvert.o: MCLConvert.cpp
	$(CC) $(FLAGS) -c -o mclconvert.o MCLConvert.cpp 
fscore.o: Fscore.cpp
	$(CC) $(FLAGS) -c -o fscore.o Fscore.cpp 



mclconvert: mclconvert.o 
	$(CC) $(FLAGS) -o mclconvert mclconvert.o 
fscore: fscore.o 
	$(CC) $(FLAGS) -o fscore fscore.o



clean:
	-rm -f mclconvert fscore *.o

=== Benchmarks/ctf/Makefile ===
BDIR=$(realpath  $(CTF_BUILD_DIR))
ifeq (,${BDIR})
  BDIR=$(shell pwd)
endif
export BDIR
export ODIR=$(BDIR)/obj
export OEDIR=$(BDIR)/obj_ext
include $(BDIR)/config.mk
export FCXX
export OFFLOAD_CXX
export LIBS

all: $(BDIR)/lib/libctf.a $(BDIR)/lib_shared/libctf.so


.PHONY: install
install: $(INSTALL_DIR)/lib/libctf.so

$(INSTALL_DIR)/lib/libctf.so: $(BDIR)/lib/libctf.a $(BDIR)/lib_shared/libctf.so
	if [ -d hptt ]; then  \
		echo "WARNING: detected HPTT installation in hptt/, you might need to also install it manually separately."; \
	fi
	if [ -d scalapack ]; then \
		echo "WARNING: detected ScaLAPACK installation in scalapack/, you might need to also install it manually separately."; \
	fi
	mkdir -p $(INSTALL_DIR)/lib $(INSTALL_DIR)/include
	cp $(BDIR)/lib/libctf.a $(INSTALL_DIR)/lib
	cp $(BDIR)/lib_shared/libctf.so $(INSTALL_DIR)/lib
	cd src/scripts && bash ./expand_includes.sh && cd ..
	mv include/ctf_all.hpp $(INSTALL_DIR)/include/ctf.hpp

.PHONY: uninstall
uninstall:
	rm $(INSTALL_DIR)/lib/libctf.a
	rm $(INSTALL_DIR)/lib/libctf.so
	rm $(INSTALL_DIR)/include/ctf.hpp


EXAMPLES = matmul-benchmark
TESTS = bivar_function bivar_transform ccsdt_map_test ccsdt_t3_to_t2 dft diag_ctr diag_sym endomorphism_cust endomorphism_cust_sp endomorphism gemm_4D multi_tsr_sym permute_multiworld readall_test readwrite_test repack scalar speye sptensor_sum subworld_gemm sy_times_ns test_suite univar_function weigh_4D  reduce_bcast

BENCHMARKS = bench_contraction bench_nosym_transp bench_redistribution model_trainer

SCALAPACK_TESTS = qr svd eigh

STUDIES = fast_diagram fast_3mm fast_sym fast_sym_4D \
          fast_tensor_ctr fast_sy_as_as_tensor_ctr fast_as_as_sy_tensor_ctr

EXECUTABLES = $(EXAMPLES) $(TESTS) $(BENCHMARKS) $(SCALAPACK_TESTS) $(STUDIES)



export EXAMPLES
export TESTS
export BENCHMARKS
export SCALAPACK_TESTS
export STUDIES



.PHONY: executables
executables: $(EXECUTABLES)
$(EXECUTABLES): $(BDIR)/lib/libctf.a


.PHONY: examples
examples: $(EXAMPLES)
$(EXAMPLES):
	$(MAKE) $@ -C examples

.PHONY: tests
tests: $(TESTS)
$(TESTS):
	$(MAKE) $@ -C test

.PHONY: scalapack_tests
scalapack_tests: $(SCALAPACK_TESTS)
$(SCALAPACK_TESTS):
	$(MAKE) $@ -C scalapack_tests

.PHONY: bench
bench: $(BENCHMARKS)
$(BENCHMARKS):
	$(MAKE) $@ -C bench

.PHONY: studies
studies: $(STUDIES)
$(STUDIES):
	$(MAKE) $@ -C studies

.PHONY: ctf_objs
ctf_objs:
	$(MAKE) ctf -C src;

.PHONY: ctflib
ctflib: ctf_objs
	$(AR) -crs $(BDIR)/lib/libctf.a $(ODIR)/*.o;

ctf_ext_objs:
	$(MAKE) ctf_ext_objs -C src_python;

.PHONY: shared
shared: ctflibso
.PHONY: ctflibso
ctflibso: export FCXX+=-fPIC
ctflibso: export OFFLOAD_CXX+=-fPIC
ctflibso: export ODIR=$(BDIR)/obj_shared
ctflibso: ctf_objs ctf_ext_objs
	$(FCXX) -shared -o $(BDIR)/lib_shared/libctf.so $(ODIR)/*.o $(OEDIR)/*.o  $(SO_LIB_PATH) $(SO_LIB_FILES) $(LDFLAGS)


PYTHON_SRC_FILES=src_python/ctf/core.pyx src_python/ctf/random.pyx

.PHONY: python
python: $(BDIR)/lib_python/ctf/core.o

$(BDIR)/lib_python/ctf/core.o: $(BDIR)/setup.py $(BDIR)/lib_shared/libctf.so $(PYTHON_SRC_FILES)
	cd src_python; \
	ln -sf $(BDIR)/setup.py setup.py; \
	mkdir -p $(BDIR)/lib_python/ctf && cp ctf/__init__.py $(BDIR)/lib_python/ctf/; \
	LDFLAGS="-L$(BDIR)/lib_shared" python setup.py build_ext --force -b $(BDIR)/lib_python/ -t $(BDIR)/lib_python/; \
	rm setup.py; \
	cd ..;


.PHONY: python_install
python_install: $(INSTALL_DIR)/lib/libctf.so pip
.PHONY: pip
pip: $(BDIR)/setup.py $(BDIR)/lib_shared/libctf.so $(PYTHON_SRC_FILES)
	cd src_python; \
	ln -sf $(BDIR)/setup.py setup.py; \
	mkdir -p $(BDIR)/lib_python/ctf && cp ctf/__init__.py $(BDIR)/lib_python/ctf/; \
	pip install --force -b $(BDIR)/lib_python/ . --upgrade; \
	rm setup.py; \
	cd ..;

.PHONY: python_uninstall
python_uninstall:
	pip uninstall ctf

.PHONY: python_test
.NOTPARALLEL: python_test
ifneq (,$(findstring USE_SCALAPACK,$(DEFS)))
python_test: python_base_test python_fancyindex_test python_einsum_test python_ufunc_test python_dot_test python_sparse_test python_la_test python_partition_test
	echo "Cyclops Python tests completed."
else
python_test: python_base_test python_fancyindex_test python_einsum_test python_ufunc_test python_dot_test python_sparse_test python_partition_test
	echo "Cyclops Python tests completed."
endif

.PHONY: python_test%
.NOTPARALLEL: python_test%
ifneq (,$(findstring USE_SCALAPACK,$(DEFS)))
python_test%: python_base_test% python_fancyindex_test% python_einsum_test% python_ufunc_test% python_dot_test% python_sparse_test% python_la_test% python_partition_test%
	echo "Cyclops Python tests completed."

else

python_test%: python_base_test% python_fancyindex_test% python_einsum_test% python_ufunc_test% python_dot_test% python_sparse_test% python_partition_test%
	echo "Cyclops Python tests completed."

endif

.PHONY: python_einsum_test
python_einsum_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_einsum.py

.PHONY: python_einsum_test%
python_einsum_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_einsum.py

.PHONY: python_ufunc_test
python_ufunc_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_ufunc.py

.PHONY: python_ufunc_test%
python_ufunc_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_ufunc.py

.PHONY: python_fancyindex_test
python_fancyindex_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_fancyindex.py

.PHONY: python_fancyindex_test%
python_fancyindex_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_fancyindex.py

.PHONY: python_base_test
python_base_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_base.py

.PHONY: python_base_test%
python_base_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_base.py

.PHONY: python_la_test
python_la_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_la.py;

.PHONY: python_la_test%
python_la_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_la.py;

.PHONY: python_dot_test
python_dot_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_dot.py;

.PHONY: python_dot_test%
python_dot_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_dot.py;

.PHONY: python_sparse_test
python_sparse_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_sparse.py;

.PHONY: python_sparse_test%
python_sparse_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_sparse.py;

.PHONY: python_partition_test
python_partition_test: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" python ./test/python/test_partition.py;

.PHONY: python_partition_test%
python_partition_test%: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" mpirun -np $* python ./test/python/test_partition.py;

.PHONY: test_live
test_live: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" ipython -i -c "import numpy as np; import ctf"

.PHONY: test_jupyter
test_jupyter: $(BDIR)/lib_python/ctf/core.o
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):$(BDIR)/lib_shared:$(BDIR)/lib_python:$(LD_LIB_PATH)" PYTHONPATH="$(PYTHONPATH):$(BDIR)/lib_python" jupyter-notebook


$(BDIR)/lib/libctf.a: src/*/*.cu src/*/*.cxx src/*/*.h src/Makefile src/*/Makefile $(BDIR)/config.mk src_python/ctf_ext.cxx src_python/ctf_ext.h
	$(MAKE) ctflib

$(BDIR)/lib_shared/libctf.so: src/*/*.cu src/*/*.cxx src/*/*.h src/Makefile src/*/Makefile $(BDIR)/config.mk src_python/ctf_ext.cxx src_python/ctf_ext.h
	$(MAKE) ctflibso
	
test: test_suite
	$(BDIR)/bin/test_suite

.PHONY: test%
test%: test_suite
	mpirun -np $* $(BDIR)/bin/test_suite


clean: clean_bin clean_lib clean_obj clean_py

clean_py:
	rm -f $(BDIR)/src_python/ctf/core.*so
	rm -f $(BDIR)/src_python/ctf/random.*so
	rm -f $(BDIR)/bin/test_suite
	rm -f $(BDIR)/src_python/ctf/core.cpp
	rm -f $(BDIR)/src_python/ctf/random.cpp
	rm -rf $(BDIR)/src_python/build
	rm -rf $(BDIR)/src_python/__pycache__
	rm -rf $(BDIR)/src_python/ctf/__pycache__
	rm -f $(BDIR)/lib_python/ctf/core.o
	rm -f $(BDIR)/lib_python/ctf/random.o
	rm -f $(BDIR)/lib_python/ctf/core.*so
	rm -f $(BDIR)/lib_python/ctf/random.*so
	rm -rf $(BDIR)/lib_python/ctf/__pycache__


clean_bin:
	for comp in $(EXECUTABLES) ; do \
		rm -f $(BDIR)/bin/$$comp ; \
	done

clean_lib:
	rm -f $(BDIR)/lib/libctf.a
	rm -f $(BDIR)/lib_shared/libctf.so
	rm -f $(BDIR)/lib_shared/libctf_ext.so

clean_obj:
	rm -f $(BDIR)/obj/*.o
	rm -f $(BDIR)/obj_ext/*.o
	rm -f $(BDIR)/obj_shared/*.o
	rm -rf $(BDIR)/obj_shared/ctf/
	rm -f $(BDIR)/build/*/*/*.o

=== debian/changelog ===
combblas (2.0.0-7) unstable; urgency=medium

  * replace debian patch cmake_multiarch.patch with cmake4_PR31.diff
    applying upstream PR#31 to update cmake definitions for cmake 4.
    Closes: #1112804.
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sun, 28 Sep 2025 01:31:35 +0200

combblas (2.0.0-6) unstable; urgency=medium

  * Team upload.
  * Drop quotes around the value of PRTE_MCA_rmaps_default_mapping_policy in
    debian/rules, since debian/rules is a Makefile and quotes are interpreted
    literally in Makefile's.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Thu, 31 Oct 2024 10:30:14 +0000

combblas (2.0.0-5) unstable; urgency=medium

  * Team upload.
  * OpenMPI 5.0 changed the name and the value of the environment variable to
    allow oversubscription from
       export OMPI_MCA_rmaps_base_oversubscribe=1
    to
       export PRTE_MCA_rmaps_default_mapping_policy=":oversubscribe"
  * OpenMPI 5.0 changed the name of the environment variable to set the SSH
    agent from
       export OMPI_MCA_plm_rsh_agent=/bin/false
    to
       export PRTE_MCA_plm_ssh_agent=/bin/false
  * Set lower bound >= 1.17 to Build-Depends: mpi-default-dev because the
    two environment variables above, PRTE_MCA_rmaps_default_mapping_policy
    and PRTE_MCA_plm_ssh_agent, are set at build time in debian/rules

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 27 Oct 2024 15:43:16 +0000

combblas (2.0.0-4) unstable; urgency=medium

  * openmpi 5 dropped libmpi_cxx.so. Rebuild.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Sat, 19 Oct 2024 14:56:14 +0200

combblas (2.0.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061882

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 17:11:06 +0000

combblas (2.0.0-3) unstable; urgency=medium

  * reinstate and update debian/patches/AWPM_library_38dd27e.patch.
    ThreadBuffLenForBinning is not yet set inline.
    GlobalMT not yet patched upstream in BipartiteMatchings headers
    BPMaximalMatching.h and BPMaximumMatching.h

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Aug 2023 02:57:33 +0200

combblas (2.0.0-2) unstable; urgency=medium

  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Aug 2023 13:04:07 +0200

combblas (2.0.0-1exp2) experimental; urgency=medium

  * use arch-indep Build-Depends-Indep: doxygen, graphviz
    for doc build
  * debian patches mpi_comm_eb4811a.diff and mpi_comm_ecf9621.diff
    apply upstream commits eb4811a and ecf9621 to fix MPI_COMM
    handling. See also SuperLU-Dist Issue #124.
  * debian/tests: run tests from both ReleaseTests and Applications
    - Applications_CMakeLists.txt.patch provides patch to enable
      Applications build against installed CombBLAS.
  * set OMPI_MCA_rmaps_base_oversubscribe=1 at build time to allow
    build-time tests to run when 4 CPUs are not available

 -- Drew Parsons <dparsons@debian.org>  Sat, 08 Jul 2023 17:31:56 +0200

combblas (2.0.0-1exp1) experimental; urgency=medium

  * New upstream release.
    - applies debian patch AWPM_library_38dd27e.patch
  * update debian/watch and copyright to new upstream repo
    https://github.com/PASSIONLab/CombBLAS
  * debian patch update_version_PR18.patch updates project version
    (see upstream PR#18)
    - update to ABI 2.0.0
  * debian/rules: remove redundant MacOS ._CombBLAS.h fix
  * update BipartiteMatchings source location (headers), now taken from
    Applications subdirectory.
  * remove doc dir after dh_clean (generated by doxygen)
  * update debian/tests/ReleaseTests_CMakeLists.txt.patch to add MPI
    links and link GenWrMat with GraphGenlib

 -- Drew Parsons <dparsons@debian.org>  Fri, 07 Jul 2023 13:31:43 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  cmake (>= 3.3),
- doxygen,
- graphviz,
- mpi-default-dev
-Standards-Version: 4.6.0
+ mpi-default-dev (>= 1.17)
+Build-Depends-Indep: doxygen,
+ graphviz
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://people.eecs.berkeley.edu/~aydin/CombBLAS/html/index.html
 Vcs-Browser: https://salsa.debian.org/science-team/combblas
@@ -17,7 +17,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcombblas1.16.0 (= ${binary:Version}), ${misc:Depends}
+Depends: libcombblas2.0.0t64 (= ${binary:Version}), ${misc:Depends}
 Suggests: libcombblas-docs
 Description: an extensible parallel graph library for graph analytics
  The Combinatorial BLAS (CombBLAS) is an extensible distributed-memory
@@ -36,7 +36,10 @@
  This package provides development files for building client
  applications against combblas.
 
-Package: libcombblas1.16.0
+Package: libcombblas2.0.0t64
+Provides: ${t64:Provides}
+Replaces: libcombblas2.0.0
+Breaks: libcombblas2.0.0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -19,12 +19,15 @@
 LIBDIR = $(CURDIR)/$(BUILDDIR)
 
 # Allow test programs that uses OpenMPI to run
-export OMPI_MCA_plm_rsh_agent=/bin/false
+export PRTE_MCA_plm_ssh_agent=/bin/false
+export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe
 
 
 %:
 	dh $@
 
+execute_after_dh_clean:
+	rm -rf doc
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -41,11 +44,6 @@
 override_dh_auto_test-indep:
 	# no tests for docs
 
-override_dh_auto_install:
-	dh_auto_install
-	# MacOS auxiliary file, should never have been installed
-	rm -f debian/tmp/usr/include/CombBLAS/._CombBLAS.h
-
 override_dh_installchangelogs:
 	dh_installchangelogs release-notes.html

=== debian/tests/control ===
Tests: test-combblas
Depends: @, @builddeps@
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/PASSIONLab/CombBLAS/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
